/*
** SellaNMS
** $Id: policy_statement_term.h,v 1.5 2006/01/24 07:08:09 sella Exp $
** Copyright (c) 2001-2005 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#ifndef __POLICY_STATEMENT_TERM_H__
#define __POLICY_STATEMENT_TERM_H__

#ifdef HAVE_CONFIG_H
	#include "config.h"
#endif
 
#include "term.h"
#include "format_statement.h"
#include "policy_statement.h"
#include "map_statement.h"

class PolicyStatement;
class PolicyStatementTerm: public Term {
	public:
		PolicyStatementTerm();
		PolicyStatementTerm(Term const &src);
		PolicyStatementTerm(PolicyStatementTerm const &src);
		virtual ~PolicyStatementTerm();
		virtual Term const& operator=(Term const &src);
		virtual PolicyStatementTerm const& operator=(PolicyStatementTerm const &src);
		RESULT setCompiledStatements( hash_map<string, PolicyStatement> *policies, hash_map<string, MapStatement> *maps);

		RESULT applyFormatStatement(FormatStatement &format);
		RESULT getReferencedVariables(slist<variable_t> &referenced);
		RESULT getAppliedMapStatements(slist<string> &map_names);
		
	protected:
		virtual From *getNewFromClause() const;
		virtual Then *getNewThenClause() const;
};

#endif

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim:
** vim: noet ts=3 sw=3 sts=3
*/
